package phonebook;

import java.util.*;
import java.util.regex.*;

public class Operator {

    public static Phonenumber parseNumber(String s) {
        Pattern p = Pattern.compile("\\+(\\d{2}) (\\d{1,2})/(\\d{6,8})");
        Matcher m = p.matcher(s);
        boolean isMatch = m.matches();
        if (isMatch) {
            return new Phonenumber(m.group(1),m.group(2),m.group(3));
        }
        return null;
    }
    
    public static void main (String[] args) {
       
        Phonebook t = new Phonebook();
        
        t.addItem("Kiss Bela", new Phonenumber("36","30","1212343"));
        t.addItem("Toth Maria", new Phonenumber("36","20","1234568"));
        t.addItem("Mekk Elek", new Phonenumber("36","70","3456789"));
        t.addItem("Toth Istvan", new Phonenumber("36","20","1234568"));

        try {
            t.addItem("Kiss Bela", new Phonenumber("36","30","7654321"));
        }
        catch (Exception e) {
            System.out.println("Megvan: " + e);
        }
        // Megvan: java.lang.UnsupportedOperationException: 
        //         Mar bejegyzett nev: Kiss Bela

        System.out.println(t);
        /*
          Kiss Bela                     +36 30/1212343
          Mekk Elek                     +36 70/3456789
          Toth Istvan                   +36 20/1234568
          Toth Maria                    +36 20/1234568
        */

        System.out.println(t.getPhonenumber("Toth Maria")); 
        // +36 20/1234568
        System.out.println(t.getNames(new Phonenumber("36","20","1234568")));
        // [Toth Maria, Toth Istvan]
        System.out.println(t.getInterestingNumbers());
        // [+36 30/1212343, +36 70/3456789]

        ////////////////////////////////////////////////////////////////////////
        // Feladat: az parancssori argumentumkent megadott szamu              //  
        // telefonkonyv bejegyzest kerjen be a program, tarolja el egy        //
        // telefonkonyvben, majd irja ki az erdekes telefonszamokat a         //
        // hozzajuk tartozo nevekkel.                                         // 
        //                                                                    //
        // A bekereskor ellenorizze, hogy a telefonszam megfelele-e a         //
        // kovetkezo formai kovetelmenyeknek:                                 //  
        // - "+" jel utan ket szamjegy (ez lesz az orszaghivo)                //
        // - 1 db szokoz, majd 1 vagy 2 szamjegyu korzetszam                  //
        // - "/" jel, utana 6-8 szamjegyu hivoszam                            //
        //                                                                    // 
        ////////////////////////////////////////////////////////////////////////
        
	System.out.println();
        System.out.println(parseNumber("+36 30/123456"));
        // +36 30/123456
        System.out.println(parseNumber("36-36/123456"));
        // null
    }

}
